import java.math.BigInteger;
import java.util.Random;

/**
 * Die Klasse RSA.
 * 
 * @author (claus albowski) 
 * @version (Mai 06)
 */
public class RSA
{
    Random random;
    int bitLength;
    BigInteger p,q,n,phi,d,e,message,code;
    
    /**
     * Konstruktor fr Objekte der Klasse RSA
     * der auch eine Initialisierung einschlielich e und d
     * durchfhrt.
     */
    public RSA()
    {
        random=new Random();
        bitLength=200;
        definiereWerte();
        setzeEundD();
    }
    
    /**
     * gibt eine zufllige Pseudoprimzahl mit der ueergebenen Bit-Lnge zurck.
     */
    public BigInteger gibZufallsPrimzahl(int bitLength){
        return BigInteger.probablePrime(bitLength, random);
    }
   
    /**
     * whlt zunchst zwei (Pseudo-)Primzahlen p und q, berechnet n und phi.
     */
    public void definiereWerte(){
        p=gibZufallsPrimzahl(bitLength);
        q=gibZufallsPrimzahl(bitLength);
        n=p.multiply(q);
        phi=(p.subtract(BigInteger.ONE)).multiply(q.subtract(BigInteger.ONE));
    }

    
    /**
     * setzt e und dazu d.
     */
    public void setzeEundD(){
        e=gibZufallsPrimzahl(2*bitLength+1).mod(phi);
        d=e.modInverse(phi);
    }
    
    /**
     * verschluesseleRSA
     */
    public String verschluesseleRSA(){
        code=message.modPow(e, n);
        return code.toString();
    }
    
    /**
     * setzt die Botschaft.
     */
    public void setzeBotschaft(String botschaft){
        message=new BigInteger(botschaft);
    }
    
    /**
     * setzt den Code.
     */
    public void setzeCode(String codeString){
        code=new BigInteger(codeString);
    }    
    
    /**
     * entschluesseleRSA
     */
    public String entschluesseleRSA(){
        message=code.modPow(d, n);
        return message.toString();
    }
    
    // ************************************************ //
    
    /**
     * setzt kleine Werte fuer eine Beispielrechnung.
     */
    public void setzeKleineWerte(){
       p = new BigInteger("1009"); 
       q = new BigInteger("1367");
       n = new BigInteger("1379303");
       phi = new BigInteger("1376928");
       e = new BigInteger("2560291");
       d =  new BigInteger("1209739");
    }
    
    /**
     * get - Methoden 
     * mssen noch entfernt werden!
     */
    public String gibP(){ return p.toString(); }
    public String gibQ(){ return q.toString(); }
    public String gibN(){ return n.toString(); }
    public String gibPhi(){ return phi.toString(); }
    public String gibE(){ return e.toString(); }
    public String gibD(){ return d.toString(); }
}
